# Additional Adjustment Yellow/Blue Mask Maker 8 & 16bit Version
# Ver. 0.18 reactive version (18th, May, 2021)
# Bug fixed: preview and actual file differance in binary mask
# (c)2021 Ohnishi, Yasuo
from ij import IJ, ImagePlus
from ij import WindowManager as WM
from ij.gui import GenericDialog, ImagePanel
from ij.io import DirectoryChooser, OpenDialog
# from ij.gui import GenericDialog
from ij import plugin
from ij.plugin import ChannelSplitter, Duplicator
from ij.plugin import RGBStackMerge, RGBStackConverter
from ij.plugin import Duplicator
from ij.plugin.filter import ThresholdToSelection
from ij.process import ImageConverter, ImageProcessor
from ij.process import ByteProcessor
from loci.plugins import BF
from java.awt.event import AdjustmentListener, ItemListener
import os
from org.python.core import codecs
codecs.setDefaultEncoding('utf-8')

#---Convert Value in 8, 16, 32bit mode
def convValue(Value, Mode):
#     Converting Luminance Value each in 8, 16, 32bit mode
        if Mode == "16-bit":
                Value = Value * 256
        elif Mode == "32-bit":
                Value = Value * 256 * 256
        else:
                Value = Value
        return Value

#----------------------------------------------
### RGB Manipulation 
def RGBmanipulation(imp0, folder,filename, baseCh, parm):
#  input Parameters
    if parm is not None: # if parm is not null, then get paraneters...
        Mode, YTh, blInvert, zoneLTh, zoneHTh, Show = parm 
#     Mode: Image Format 16-bit or 8-bit
#     YTh: yellow(or blue) value threshold of mask
#     zoneLTh: lower threshold of mask
#     zoneHTh: upper threshold of mask
#     blinvert: make blue mask or not
#     Show: show working windows or not
# Windows Showing Mode
        imp0.show()
    impsCh = ChannelSplitter.split(imp0) #Channel Splitting of imp0
    for i in impsCh: # it needs to convert Grayscale image
        if Mode == "8-bit":
            ImageConverter(i).convertToGray8()
        elif Mode == "16-bit":
            ImageConverter(i).convertToGray16()
        else:
            ImageConverter(i).convertToGray32()
## R ch.
    impR =  impsCh[0]
## G ch.
    impG =  impsCh[1]
## B ch. & B x 0.3
    impB =  impsCh[2]
# Show Windows
#    imp0.close()
    if Show == "Yes":
        impR.show()
        impG.show()
        impB.show()
# G ch. x 0.5
    impG05 = Duplicator().run(impG)
    IJ.run(impG05, "Multiply...", "value=0.5")
    if Show == "Yes":
        impG05.show()
# R ch. x 0.5
    impR05 = Duplicator().run(impR)
    IJ.run(impR05, "Multiply...", "value=0.5")
    if Show == "Yes":
        impR05.show()
# R x 0.5 + G x 0.5
    ic = plugin.ImageCalculator()
    impRG = ic.run("Add created", impR05, impG05)
# Close Windows
    if Show == "Yes":
        imp0.hide()
        impR.hide()
        impG.hide()
        impB.hide()
        impRG.show()
        impG05.hide()
        impR05.hide()
    impG05.close()
    impR05.close()
# (R x 0.5 + G x 0.5) - B
    ic = plugin.ImageCalculator()
# Make Yellow Image Files 
# in each Threshold, Make 3 kinds of Image Files: x1, x2, x4 
    V = str(YTh)
# Yellow Mask Threshold
    V2 = str(convValue(abs(YTh), Mode)) # actual Yellow mask Threshold
    if blInvert == False:
        # for making Yellow mask
           # Set the Threshold in R + G Image
        if YTh < 0: # restrict less region for yellow mask
            print (YTh, "Subtract", V)
            IJ.run(impRG, "Subtract...","value=" + V2)
            V= "-" + V
        else:  #including more region for yellow mask
            print (YTh, "Add", V)
            IJ.run(impRG, "Add...", "value=" + V2)
            V= "+" + V
        impYmask = ic.run("Subtract created", impRG, impB) # Make Yellow Mask
        V = "Y" + V
    else:
     # for making Blue mask
         # Set the Threshold in R + G Image
        if YTh >= 0:  #including more region for blue mask
            print (YTh, "Subtract", V)
            IJ.run(impRG, "Subtract...","value=" + V2)
            V= "+" + V
        else: # restrict less region for blue mask
            print (YTh, "Add", V)
            IJ.run(impRG, "Add...", "value=" + V2)
            V= "-" + V
        impYmask = ic.run("Subtract created", impB, impRG) # Make Blue Mask
        V = "B" + V
#       IJ.saveAsTiff(imp6, folder + filename +"_YMask_Thr_"+ V + "_x1.tif") # Save the Subtracted image x 1
    if Show == "Yes":
        impYmask.show()  # Show the subtracted image in window
    IJ.run(impYmask, "Multiply...", "value=4") # making mask more transparent (x 4)
#    if blInvert == True:
#        impYmask.getProcessor().invert()
#        V = V + "Inv"
    IJ.saveAsTiff(impYmask, folder + filename + "_Mask_Thr_".decode('utf-8') + V.decode('utf-8') + "_x4.tif".decode('utf-8')) # Save the Subtracted image x 4
#   save Yellow / Blue mask
    impRG.hide()
    impRG.close()
#############################################################
# select base channel for deciding mask upper and lower threshold
    if baseCh == "RGBtoGRAY":
        impZone = Duplicator().run(imp0)
        IJ.run(impZone, "Conversions...", "weighted")
        baseCh2 = "_GRY_"
    elif baseCh == "Blue":
        impZone = Duplicator().run(impB)
        baseCh2 = "_B_"
    elif baseCh == "Red":
        impZone = Duplicator().run(impR)
        baseCh2 = "_R_"
    elif baseCh == "Green":
        impZone = Duplicator().run(impG)
        baseCh2 = "_G_"
    ImageConverter(impZone).setDoScaling(True)
    ImageConverter(impZone).convertToGray8() 
               # always use 8bit image for making binary mask (Ver. 0.17)
    impR.close()
    impG.close()
    impB.close()
    imp0.close()
    ip = impZone.getProcessor()
    mask = ByteProcessor(ip.width, ip.height)
    mask.setValue(255)
    if Show == "Yes":
        impZone.show()
# make Zone mask (always in 8bit mode after Ver. 0.17)
    impZone.getProcessor().setThreshold(zoneLTh, zoneHTh, ImageProcessor.NO_LUT_UPDATE)
    print "Zone L & H", convValue(zoneLTh, Mode), convValue(zoneHTh, Mode)
    roi = ThresholdToSelection.run(impZone)
    mask.setRoi(roi)
    mask.fill(roi)
    try:
        maskimp = ImagePlus("Mask", mask) # only 8bit Zone mask made from ROI: Zone mask: maskimp
    except: # exception process for ROI missing
        IJ.error("Selected ROI (Region of Interest) is missing.")
        if Show == "Yes":
            impYmask.hide()
            impZone.hide()
        impYmask.close()
        impZone.close()
        return
    if Show == "Yes":
        maskimp.show() # show Zone mask
# deepen Zone Mask bit depth  (8bit to 16 or 32 bit)      
    if Mode == "16-bit":
        ImageConverter(maskimp).convertToGray16()
    elif Mode == "32-bit":
        ImageConverter(maskimp).convertToGray32()
    IJ.run(maskimp, "Multiply...", "value=" + str(convValue(1, Mode)))
#        Save Zone Mask
    IJ.saveAsTiff(maskimp, folder + filename + baseCh2 + "Zone" + str(int(zoneLTh)) + "-" + str(int(zoneHTh)) + "_Mask.tif")
# bind Zone mask and Yellow / blue mask
    ic = plugin.ImageCalculator()
    maskBindimp = ic.run("Min created", impYmask, maskimp) # bind masks
    if Show == "Yes":
        maskBindimp.show()
    IJ.saveAsTiff(maskBindimp, folder + filename  + baseCh2 + "Zone" + str(int(zoneLTh)) + "-" + str(int(zoneHTh)) + "_" + V + "_Mask_Binded.tif")
#     save binded mask
    if Show == "Yes":
        impYmask.hide()
        impZone.hide()
        maskimp.hide()
        maskBindimp.hide()
    impYmask.close()
    maskimp.close()
    maskBindimp.close()
    impZone.close()
#   End of def RGBmanipulation 
#----------------------------------------------

class ThresholdPreviewer(AdjustmentListener, ItemListener): # observe changes of dialog items
    def __init__(self, imp, slider_upper, slider_lower, checkbox_prv):
        """
             imp: an ImagePlus
             slider: a java.awt.Scrollbar UI element
             preview_checkbox: a java.awt.Checkbox controlling whether to
                                                 dynamically update the ImagePlus as the
                                                 scrollbar is updated, or not.
        """
        self.imp = imp
        self.original_ip = imp.getProcessor().duplicate() # store a copy
        self.imp_org = Duplicator().run(imp0)
        self.slider_upper = slider_upper
        self.slider_lower = slider_lower
        self.checkbox_prv = checkbox_prv

    def adjustmentValueChanged(self, event):
        """ event: an AdjustmentEvent with data on the state of the scroll bar. """
        preview = self.checkbox_prv.getState()
        if preview:
            if event.getValueIsAdjusting():
                return # there are more scrollbar adjustment events queued already
            self.threshold()

    def itemStateChanged(self, event):
        """ event: an ItemEvent with data on what happened to the checkbox. """
        if event.getStateChange() == event.SELECTED:
            self.threshold()
    
    def reset(self):
        """ Restore the original ImageProcessor """
        self.imp.setProcessor(self.original_ip)
    
    def threshold(self):
        """ Execute the in-place making binary image of the ImagePlus. """
        ip = self.imp.getProcessor()
        mask = ip.createProcessor(ip.width, ip.height)
        mask.BLACK_AND_WHITE_LUT
        mask.setValue(convValue(255, Mode))
        threshold_upper = self.slider_upper.getValue()
        threshold_lower = self.slider_lower.getValue()
        if threshold_upper < threshold_lower:
            threshold_upper = threshold_lower
        self.original_ip.setThreshold(threshold_lower, threshold_upper, ImageProcessor.OVER_UNDER_LUT)
        roi = ThresholdToSelection().convert(self.original_ip) # make ROI from threshold
        mask.setRoi(roi) # applicate roi to mask
        mask.fill(roi)   # fill with 255 in the roi
        self.imp.setProcessor(mask) # applicate mask to imp
        self.imp.getProcessor().setLut (None) # reset LUT of imp


def thresholdImageUI(imp, Mode):
    ImageConverter(imp).convertToGray8()
#    imp = WM.getCurrentImage()
#    imp.plotHistogram()
    WM.getActiveWindow().toFront()
#    imppanel = ImagePanel(imp)
    gd = GenericDialog("Yellow (Blue) Mask Maker / input threshold parameters")
    gd.addNumericField("Yellow Mask Threshold (-20 to 30)", 10, 0)
    gd.addCheckbox("Mask Invert for Blue Mask", False)
    gd.addSlider("Upper Threshold of Mask", 0, 255, 128)
    gd.addSlider("Lower Threshold of Mask", 0, 255, 128)
    gd.addCheckbox("Preview", True)
    showWin = ["Yes","No"]
    gd.addChoice("Show working windows?", showWin, showWin[0])

    # The UI elements for the above two inputs
    slider_upper = gd.getSliders().get(0) # the 1st
    slider_lower = gd.getSliders().get(1) # the 2nd
    checkbox_Bmask = gd.getCheckboxes().get(0) #  chkbox for blue mask
    checkbox_prv = gd.getCheckboxes().get(1) # chkbox for preview
    nfield_maskThr = gd.getNumericFields().get(0) # 1st start
    choice_showWin = gd.getChoices().get(0)


    if not imp:
        print "Open an image first!"
        return

    previewer = ThresholdPreviewer(imp, slider_upper, slider_lower, checkbox_prv)
    slider_upper.addAdjustmentListener(previewer) # set listener for upper slider
    slider_lower.addAdjustmentListener(previewer) # set listener for lower slider
    checkbox_prv.addItemListener(previewer)  # set listener for preview checkbox
    
    gd.showDialog()

    if gd.wasCanceled():
        previewer.reset()
        Mode = "Stop"
        print "User canceled dialog!"
#    else:
#        previewer.threshold()
#    parm_Mode   = "Auto"
    YTh =  gd.getNextNumber()
    blInvert = gd.getNextBoolean()
    zoneHTh =  gd.getNextNumber()
    zoneLTh =  gd.getNextNumber()
    Show =  gd.getNextChoice()
    imp.hide()
    imp.close()
    return Mode, YTh, blInvert, zoneLTh, zoneHTh, str(Show)


def selectChannel(): # dialog of selecting target channel for mask upper & lower threshold
    gd = GenericDialog("Yellow (Blue) Mask Maker / Target Channel Selection")
    sbaseCh = ["RGBtoGRAY","Red","Green","Blue"]
    gd.addChoice("Select Target Channel for deciding upper & lower threshold", sbaseCh, sbaseCh[3])
    gd.showDialog()

    baseCh =  gd.getNextChoice()
    if gd.wasCanceled():
        baseCh =  "None"

    return str(baseCh)

#----------main----------
window = WM.getActiveWindow()
Mode = "Auto"
if not window:
    od = OpenDialog("Choose a file")
    folder = od.getDirectory()
    filename = od.getFileName()
    if filename:
        path = folder + filename
        IJ.log(path)
        IJ.log(folder)
        IJ.log(filename)
# Always Open file with Bio-format Plugin
        imps = BF.openImagePlus(folder + filename) # Open file with Bio-format Plugin
        imp0 = imps[0] #imp0: Original Image 
        imp0.show()
    else:
        Mode = "Stop"
else:
    imp0 = IJ.getImage()
    filename = imp0.getTitle()
    folder = IJ.getDirectory("image") # get image's original directory
    folder = IJ.getDirectory("Output_directory")
if Mode == "Auto":
    bitdepth = imp0.getBitDepth()
    if bitdepth == 8:
            Mode = "8-bit"
    elif bitdepth ==16:
            Mode = "16-bit"
    elif bitdepth ==32:
            Mode = "32-bit"
    else:
            Mode = "16-bit"
if Mode <> "Stop": # if user did not cancel execute process
    impprv = Duplicator().run(imp0) # impprv: preview imp
    scale = 1200.0 / impprv.getWidth() # preview image scaling value (width = 1200px fixed)
    new_height = impprv.getHeight() * scale # preview image height
    new_height = int(new_height)
    tmpimpprv = impprv.resize(1200, new_height, "none")
    ImageConverter(tmpimpprv).convertToRGB() # convert to 8bit RGB
    impprvsCh = ChannelSplitter.split(tmpimpprv)
    
    baseCh = selectChannel() # select target channel for deciding upper & lower threshold
    if baseCh:
        imp0.hide()
        if baseCh == "Blue":
            impprvsCh[2].show()
            parm = thresholdImageUI(impprvsCh[2], Mode)
        elif baseCh == "Red":
            impprvsCh[0].show()
            parm = thresholdImageUI(impprvsCh[0], Mode)
        elif baseCh == "Green":
            impprvsCh[1].show()
            parm = thresholdImageUI(impprvsCh[1], Mode)
        else:
    #        ImageConverter(impprv).convertToRGB()
            ImageConverter(tmpimpprv).convertToGray8()
            tmpimpprv.show()
            parm = thresholdImageUI(tmpimpprv, Mode)
    else:
        parm = []
        parm.append("Stop")
    tmpimpprv.hide()
    impprvsCh[0].hide()
    impprvsCh[1].hide()
    impprvsCh[2].hide()
    tmpimpprv.close()
    impprvsCh[0].close()
    impprvsCh[1].close()
    impprvsCh[2].close()
    
    if parm[0] <> "Stop":
        RGBmanipulation(imp0, folder, filename, baseCh, parm)
else:
    IJ.log("User canceled")
IJ.log("Finish")

